/**
 */
package org.eclipse.gemoc.activitydiagram.sequential.activitydiagram.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.gemoc.activitydiagram.sequential.activitydiagram.Activity;
import org.eclipse.gemoc.activitydiagram.sequential.activitydiagram.ActivityEdge;
import org.eclipse.gemoc.activitydiagram.sequential.activitydiagram.ActivityNode;
import org.eclipse.gemoc.activitydiagram.sequential.activitydiagram.ActivitydiagramPackage;
import org.eclipse.gemoc.activitydiagram.sequential.activitydiagram.Token;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Activity Node</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.gemoc.activitydiagram.sequential.activitydiagram.impl.ActivityNodeImpl#getOutgoing <em>Outgoing</em>}</li>
 *   <li>{@link org.eclipse.gemoc.activitydiagram.sequential.activitydiagram.impl.ActivityNodeImpl#getIncoming <em>Incoming</em>}</li>
 *   <li>{@link org.eclipse.gemoc.activitydiagram.sequential.activitydiagram.impl.ActivityNodeImpl#getActivity <em>Activity</em>}</li>
 *   <li>{@link org.eclipse.gemoc.activitydiagram.sequential.activitydiagram.impl.ActivityNodeImpl#isRunning <em>Running</em>}</li>
 *   <li>{@link org.eclipse.gemoc.activitydiagram.sequential.activitydiagram.impl.ActivityNodeImpl#getHeldTokens <em>Held Tokens</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ActivityNodeImpl extends NamedElementImpl implements ActivityNode {
	/**
	 * The cached value of the '{@link #getOutgoing() <em>Outgoing</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOutgoing()
	 * @generated
	 * @ordered
	 */
	protected EList<ActivityEdge> outgoing;

	/**
	 * The cached value of the '{@link #getIncoming() <em>Incoming</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIncoming()
	 * @generated
	 * @ordered
	 */
	protected EList<ActivityEdge> incoming;

	/**
	 * The default value of the '{@link #isRunning() <em>Running</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isRunning()
	 * @generated
	 * @ordered
	 */
	protected static final boolean RUNNING_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isRunning() <em>Running</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isRunning()
	 * @generated
	 * @ordered
	 */
	protected boolean running = RUNNING_EDEFAULT;

	/**
	 * The cached value of the '{@link #getHeldTokens() <em>Held Tokens</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHeldTokens()
	 * @generated
	 * @ordered
	 */
	protected EList<Token> heldTokens;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ActivityNodeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ActivitydiagramPackage.Literals.ACTIVITY_NODE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ActivityEdge> getOutgoing() {
		if (outgoing == null) {
			outgoing = new EObjectWithInverseResolvingEList<ActivityEdge>(ActivityEdge.class, this,
					ActivitydiagramPackage.ACTIVITY_NODE__OUTGOING, ActivitydiagramPackage.ACTIVITY_EDGE__SOURCE);
		}
		return outgoing;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ActivityEdge> getIncoming() {
		if (incoming == null) {
			incoming = new EObjectWithInverseResolvingEList<ActivityEdge>(ActivityEdge.class, this,
					ActivitydiagramPackage.ACTIVITY_NODE__INCOMING, ActivitydiagramPackage.ACTIVITY_EDGE__TARGET);
		}
		return incoming;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Activity getActivity() {
		if (eContainerFeatureID() != ActivitydiagramPackage.ACTIVITY_NODE__ACTIVITY)
			return null;
		return (Activity) eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetActivity(Activity newActivity, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newActivity, ActivitydiagramPackage.ACTIVITY_NODE__ACTIVITY, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setActivity(Activity newActivity) {
		if (newActivity != eInternalContainer()
				|| (eContainerFeatureID() != ActivitydiagramPackage.ACTIVITY_NODE__ACTIVITY && newActivity != null)) {
			if (EcoreUtil.isAncestor(this, newActivity))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newActivity != null)
				msgs = ((InternalEObject) newActivity).eInverseAdd(this, ActivitydiagramPackage.ACTIVITY__NODES,
						Activity.class, msgs);
			msgs = basicSetActivity(newActivity, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ActivitydiagramPackage.ACTIVITY_NODE__ACTIVITY,
					newActivity, newActivity));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isRunning() {
		return running;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRunning(boolean newRunning) {
		boolean oldRunning = running;
		running = newRunning;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ActivitydiagramPackage.ACTIVITY_NODE__RUNNING,
					oldRunning, running));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Token> getHeldTokens() {
		if (heldTokens == null) {
			heldTokens = new EObjectContainmentEList<Token>(Token.class, this,
					ActivitydiagramPackage.ACTIVITY_NODE__HELD_TOKENS);
		}
		return heldTokens;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
		case ActivitydiagramPackage.ACTIVITY_NODE__OUTGOING:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getOutgoing()).basicAdd(otherEnd, msgs);
		case ActivitydiagramPackage.ACTIVITY_NODE__INCOMING:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getIncoming()).basicAdd(otherEnd, msgs);
		case ActivitydiagramPackage.ACTIVITY_NODE__ACTIVITY:
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			return basicSetActivity((Activity) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
		case ActivitydiagramPackage.ACTIVITY_NODE__OUTGOING:
			return ((InternalEList<?>) getOutgoing()).basicRemove(otherEnd, msgs);
		case ActivitydiagramPackage.ACTIVITY_NODE__INCOMING:
			return ((InternalEList<?>) getIncoming()).basicRemove(otherEnd, msgs);
		case ActivitydiagramPackage.ACTIVITY_NODE__ACTIVITY:
			return basicSetActivity(null, msgs);
		case ActivitydiagramPackage.ACTIVITY_NODE__HELD_TOKENS:
			return ((InternalEList<?>) getHeldTokens()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
		case ActivitydiagramPackage.ACTIVITY_NODE__ACTIVITY:
			return eInternalContainer().eInverseRemove(this, ActivitydiagramPackage.ACTIVITY__NODES, Activity.class,
					msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case ActivitydiagramPackage.ACTIVITY_NODE__OUTGOING:
			return getOutgoing();
		case ActivitydiagramPackage.ACTIVITY_NODE__INCOMING:
			return getIncoming();
		case ActivitydiagramPackage.ACTIVITY_NODE__ACTIVITY:
			return getActivity();
		case ActivitydiagramPackage.ACTIVITY_NODE__RUNNING:
			return isRunning();
		case ActivitydiagramPackage.ACTIVITY_NODE__HELD_TOKENS:
			return getHeldTokens();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case ActivitydiagramPackage.ACTIVITY_NODE__OUTGOING:
			getOutgoing().clear();
			getOutgoing().addAll((Collection<? extends ActivityEdge>) newValue);
			return;
		case ActivitydiagramPackage.ACTIVITY_NODE__INCOMING:
			getIncoming().clear();
			getIncoming().addAll((Collection<? extends ActivityEdge>) newValue);
			return;
		case ActivitydiagramPackage.ACTIVITY_NODE__ACTIVITY:
			setActivity((Activity) newValue);
			return;
		case ActivitydiagramPackage.ACTIVITY_NODE__RUNNING:
			setRunning((Boolean) newValue);
			return;
		case ActivitydiagramPackage.ACTIVITY_NODE__HELD_TOKENS:
			getHeldTokens().clear();
			getHeldTokens().addAll((Collection<? extends Token>) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case ActivitydiagramPackage.ACTIVITY_NODE__OUTGOING:
			getOutgoing().clear();
			return;
		case ActivitydiagramPackage.ACTIVITY_NODE__INCOMING:
			getIncoming().clear();
			return;
		case ActivitydiagramPackage.ACTIVITY_NODE__ACTIVITY:
			setActivity((Activity) null);
			return;
		case ActivitydiagramPackage.ACTIVITY_NODE__RUNNING:
			setRunning(RUNNING_EDEFAULT);
			return;
		case ActivitydiagramPackage.ACTIVITY_NODE__HELD_TOKENS:
			getHeldTokens().clear();
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case ActivitydiagramPackage.ACTIVITY_NODE__OUTGOING:
			return outgoing != null && !outgoing.isEmpty();
		case ActivitydiagramPackage.ACTIVITY_NODE__INCOMING:
			return incoming != null && !incoming.isEmpty();
		case ActivitydiagramPackage.ACTIVITY_NODE__ACTIVITY:
			return getActivity() != null;
		case ActivitydiagramPackage.ACTIVITY_NODE__RUNNING:
			return running != RUNNING_EDEFAULT;
		case ActivitydiagramPackage.ACTIVITY_NODE__HELD_TOKENS:
			return heldTokens != null && !heldTokens.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (running: ");
		result.append(running);
		result.append(')');
		return result.toString();
	}

} //ActivityNodeImpl
