package thingml.xthingml.checks

import org.eclipse.xtext.validation.Check
import thingml.xthingml.thingML.StateContainer
import thingml.xthingml.thingML.ThingMLPackage
import thingml.xthingml.xtext.validation.Tarjan
import thingml.xthingml.xtext.validation.ThingMLValidatorCheck

class AutotransitionCycles extends ThingMLValidatorCheck {
	
	@Check(FAST)
	def checkAutotransitionCycles(StateContainer c) {
		val verts = newHashSet()
		verts.addAll(c.substate)
		val tarjan = new Tarjan(null, verts)
		val cycles = tarjan.findStronglyConnectedComponents();
		
		cycles.forEach[ cycle |
			if (cycle !== null && cycle.size > 1) {
				val msg = cycle.join("Auto transition cycle: (",", ",")",[name])
				cycle.forEach[ state |
					error(msg, c, ThingMLPackage.eINSTANCE.stateContainer_Substate, c.substate.indexOf(state), "autotransition-cycle")
				]
			}
		]
	}
}