/*
 * generated by Xtext 2.14.0
 */
package thingml.xthingml.xtext.validation

import java.util.LinkedList
import org.eclipse.xtext.validation.Check
import thingml.xthingml.thingML.Thing
import thingml.xthingml.thingML.ThingMLPackage

/**
 * This class contains custom validation rules. 
 *
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#validation
 */
class XThingMLValidator extends AbstractXThingMLValidator {
	
	@Check
	def checkNoCyclesInThingIncludes(Thing thing) {
		if(thing.includes.isEmpty) return;

		val visitedThings = newHashSet(thing);
		var toCheck = new LinkedList<Thing>();
		toCheck.addAll(thing.includes);

		while (!toCheck.empty) {
			val current = toCheck.pollFirst

			if (visitedThings.contains(current)) {
				error("Cycle in the hierarchy of Thing '" + current.name + "'",
					ThingMLPackage.eINSTANCE.thing_Includes);
				return;
			}

			visitedThings.add(current);
			for (Thing t : current.includes)
				if(!toCheck.contains(t)) toCheck.add(t);
		}
	}
	
}
