package thingml.xthingml.checks;

import java.util.HashSet;
import java.util.List;
import java.util.function.Consumer;
import org.eclipse.xtext.validation.Check;
import org.eclipse.xtext.validation.CheckType;
import org.eclipse.xtext.xbase.lib.CollectionLiterals;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import thingml.xthingml.thingML.StateContainer;
import thingml.xthingml.thingML.ThingMLPackage;
import thingml.xthingml.xtext.validation.Tarjan;
import thingml.xthingml.xtext.validation.ThingMLValidatorCheck;

@SuppressWarnings("all")
public class AutotransitionCycles extends ThingMLValidatorCheck {
  @Check(CheckType.FAST)
  public void checkAutotransitionCycles(final StateContainer c) {
    final HashSet<thingml.xthingml.thingML.State> verts = CollectionLiterals.<thingml.xthingml.thingML.State>newHashSet();
    verts.addAll(c.getSubstate());
    final Tarjan<thingml.xthingml.thingML.State> tarjan = new Tarjan<thingml.xthingml.thingML.State>(null, verts);
    final List<List<thingml.xthingml.thingML.State>> cycles = tarjan.findStronglyConnectedComponents();
    final Consumer<List<thingml.xthingml.thingML.State>> _function = (List<thingml.xthingml.thingML.State> cycle) -> {
      if (((cycle != null) && (cycle.size() > 1))) {
        final Function1<thingml.xthingml.thingML.State, CharSequence> _function_1 = (thingml.xthingml.thingML.State it) -> {
          return it.getName();
        };
        final String msg = IterableExtensions.<thingml.xthingml.thingML.State>join(cycle, "Auto transition cycle: (", ", ", ")", _function_1);
        final Consumer<thingml.xthingml.thingML.State> _function_2 = (thingml.xthingml.thingML.State state) -> {
          this.error(msg, c, ThingMLPackage.eINSTANCE.getStateContainer_Substate(), c.getSubstate().indexOf(state), "autotransition-cycle");
        };
        cycle.forEach(_function_2);
      }
    };
    cycles.forEach(_function);
  }
}
