package thingml.xthingml.aspects;

import com.google.common.collect.ImmutableList;
import fr.inria.diverse.k3.al.annotationprocessor.Aspect;
import fr.inria.diverse.k3.al.annotationprocessor.OverrideAspectMethod;
import java.util.List;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.Functions.Function2;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.eclipse.xtext.xbase.lib.ListExtensions;
import thingml.xthingml.thingML.Expression;
import thingml.xthingml.thingML.SendAction;
import thingml.xthingml.thingML.DynamicInstance;
import thingml.xthingml.thingML.DynamicMessage;
import thingml.xthingml.thingML.DynamicPort;
import thingml.xthingml.thingML.ThingMLFactory;
import thingml.xthingml.thingML.Value;
import thingml.xthingml.aspects.AAction;
import thingml.xthingml.aspects.ADynamicInstance;
import thingml.xthingml.aspects.AExpression;
import thingml.xthingml.aspects.ASendActionSendActionAspectProperties;
import thingml.xthingml.aspects.AValue;
import thingml.utils.Log;

@Aspect(className = SendAction.class)
@SuppressWarnings("all")
public class ASendAction extends AAction {
  @OverrideAspectMethod
  public static void execute(final SendAction _self, final DynamicInstance dynamicInstance) {
	final thingml.xthingml.aspects.ASendActionSendActionAspectProperties _self_ = thingml.xthingml.aspects.ASendActionSendActionAspectContext
			.getSelf(_self);
	_privk3_execute(_self_, _self, dynamicInstance);
	;
}
  
  @OverrideAspectMethod
  public static String _str(final SendAction _self) {
	final thingml.xthingml.aspects.ASendActionSendActionAspectProperties _self_ = thingml.xthingml.aspects.ASendActionSendActionAspectContext
			.getSelf(_self);
	Object result = null;
	result = _privk3__str(_self_, _self);
	;
	return (java.lang.String) result;
}
  
  private static void super_execute(final SendAction _self, final DynamicInstance dynamicInstance) {
    final thingml.xthingml.aspects.AActionActionAspectProperties _self_ = thingml.xthingml.aspects.AActionActionAspectContext.getSelf(_self);
     thingml.xthingml.aspects.AAction._privk3_execute(_self_, _self,dynamicInstance);
  }
  
  protected static void _privk3_execute(final ASendActionSendActionAspectProperties _self_, final SendAction _self, final DynamicInstance dynamicInstance) {
    final Function1<Expression, Value> _function = (Expression e) -> {
      return AExpression.value(e, dynamicInstance, false);
    };
    final List<Value> paramValues = ImmutableList.<Value>copyOf(ListExtensions.<Expression, Value>map(_self.getParameters(), _function));
    final Function2<String, Value, String> _function_1 = (String str, Value v) -> {
      String __str = AValue._str(v);
      String _plus = (str + __str);
      return (_plus + ", ");
    };
    String paramsString = IterableExtensions.<Value, String>fold(paramValues, "", _function_1);
    int _length = paramsString.length();
    boolean _greaterEqualsThan = (_length >= 2);
    if (_greaterEqualsThan) {
      int _length_1 = paramsString.length();
      int _minus = (_length_1 - 2);
      paramsString = paramsString.substring(0, _minus);
    }
    String recipients = "";
    EList<DynamicPort> _connectedPorts = ADynamicInstance.getDynamicPort(dynamicInstance, _self.getPort()).getConnectedPorts();
    for (final DynamicPort recipient : _connectedPorts) {
      {
        final DynamicMessage dynamicMessage = ThingMLFactory.eINSTANCE.createDynamicMessage();
        dynamicMessage.setMessage(_self.getMessage());
        for (final Value value : paramValues) {
          dynamicMessage.getParameters().add(AValue.deepCopy(value));
        }
        boolean _contains = recipient.getPort().getReceives().contains(_self.getMessage());
        if (_contains) {
          String _recipients = recipients;
          EObject _eContainer = recipient.eContainer();
          String _name = ((DynamicInstance) _eContainer).getInstance().getName();
          String _plus = (_name + ".");
          String _name_1 = recipient.getPort().getName();
          String _plus_1 = (_plus + _name_1);
          String _plus_2 = (_plus_1 + ", ");
          recipients = (_recipients + _plus_2);
          recipient.getReceivedMessages().add(dynamicMessage);
        }
      }
    }
    int _length_2 = recipients.length();
    boolean _greaterThan = (_length_2 > 2);
    if (_greaterThan) {
      int _length_3 = recipients.length();
      int _minus_1 = (_length_3 - 2);
      recipients = recipients.substring(0, _minus_1);
    }
    String _name = dynamicInstance.getInstance().getName();
    String _plus = (_name + ".");
    String __str = ASendAction._str(_self);
    String _plus_1 = (_plus + __str);
    String _plus_2 = (_plus_1 + " -> [");
    String _plus_3 = (_plus_2 + recipients);
    String _plus_4 = (_plus_3 + "]");
    Log.log(_plus_4);
  }
  
  private static String super__str(final SendAction _self) {
    final thingml.xthingml.aspects.AActionActionAspectProperties _self_ = thingml.xthingml.aspects.AActionActionAspectContext.getSelf(_self);
    return  thingml.xthingml.aspects.AAction._privk3__str(_self_, _self);
  }
  
  protected static String _privk3__str(final ASendActionSendActionAspectProperties _self_, final SendAction _self) {
    final Function2<String, Expression, String> _function = (String s, Expression p) -> {
      String __str = AExpression._str(p);
      String _plus = (s + __str);
      return (_plus + ", ");
    };
    String params = IterableExtensions.<Expression, String>fold(_self.getParameters(), "", _function);
    int _length = params.length();
    boolean _greaterThan = (_length > 2);
    if (_greaterThan) {
      int _length_1 = params.length();
      int _minus = (_length_1 - 2);
      params = params.substring(0, _minus);
    }
    String _name = _self.getPort().getName();
    String _plus = (_name + "!");
    String _name_1 = _self.getMessage().getName();
    String _plus_1 = (_plus + _name_1);
    String _plus_2 = (_plus_1 + "(");
    String _plus_3 = (_plus_2 + params);
    return (_plus_3 + ")");
  }
}
