package thingml.xthingml.aspects;

import com.google.common.base.Objects;
import com.google.common.collect.Iterables;
import fr.inria.diverse.k3.al.annotationprocessor.Aspect;
import fr.inria.diverse.k3.al.annotationprocessor.Step;
import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import thingml.xthingml.thingML.Action;
import thingml.xthingml.thingML.CompositeState;
import thingml.xthingml.thingML.Event;
import thingml.xthingml.thingML.FinalState;
import thingml.xthingml.thingML.Handler;
import thingml.xthingml.thingML.Instance;
import thingml.xthingml.thingML.InternalTransition;
import thingml.xthingml.thingML.ReceiveMessage;
import thingml.xthingml.thingML.State;
import thingml.xthingml.thingML.Transition;
import thingml.xthingml.thingML.DynamicCompositeState;
import thingml.xthingml.thingML.DynamicInstance;
import thingml.xthingml.thingML.DynamicMessage;
import thingml.xthingml.aspects.AAction;
import thingml.xthingml.aspects.ADynamicInstance;
import thingml.xthingml.aspects.AHandler;
import thingml.xthingml.aspects.AInstance;
import thingml.xthingml.aspects.AStateStateAspectProperties;
import thingml.utils.Log;

@Aspect(className = State.class)
@SuppressWarnings("all")
public class AState {
  public static EList<CompositeState> _getRootPath(final State _self, final State state) {
	final thingml.xthingml.aspects.AStateStateAspectProperties _self_ = thingml.xthingml.aspects.AStateStateAspectContext
			.getSelf(_self);
	Object result = null;
	result = _privk3__getRootPath(_self_, _self, state);
	;
	return (org.eclipse.emf.common.util.EList) result;
}
  
  public static EList<CompositeState> _getPathToState(final State _self, final DynamicInstance dynamicInstance, final State state1, final State state2) {
	final thingml.xthingml.aspects.AStateStateAspectProperties _self_ = thingml.xthingml.aspects.AStateStateAspectContext
			.getSelf(_self);
	Object result = null;
	result = _privk3__getPathToState(_self_, _self, dynamicInstance, state1, state2);
	;
	return (org.eclipse.emf.common.util.EList) result;
}
  
  public static void _switchState(final State _self, final DynamicInstance dynamicInstance, final State newState) {
	final thingml.xthingml.aspects.AStateStateAspectProperties _self_ = thingml.xthingml.aspects.AStateStateAspectContext
			.getSelf(_self);
	_privk3__switchState(_self_, _self, dynamicInstance, newState);
	;
}
  
  @Step
  public static boolean runASpontaneousTransition(final State _self, final DynamicInstance dynamicInstance) {
	final thingml.xthingml.aspects.AStateStateAspectProperties _self_ = thingml.xthingml.aspects.AStateStateAspectContext
			.getSelf(_self);
	Object result = null;
	if (_self instanceof thingml.xthingml.thingML.FinalState) {
		fr.inria.diverse.k3.al.annotationprocessor.stepmanager.StepCommand command = new fr.inria.diverse.k3.al.annotationprocessor.stepmanager.StepCommand() {
			@Override
			public void execute() {
				addToResult(thingml.xthingml.aspects.AState._privk3_runASpontaneousTransition(_self_,
						(thingml.xthingml.thingML.FinalState) _self, dynamicInstance));
			}
		};
		fr.inria.diverse.k3.al.annotationprocessor.stepmanager.IStepManager manager = fr.inria.diverse.k3.al.annotationprocessor.stepmanager.StepManagerRegistry
				.getInstance().findStepManager(_self);
		if (manager != null) {
			manager.executeStep(_self, command, "State", "runASpontaneousTransition");
		} else {
			command.execute();
		}
		result = command.getResult();
		;
	} else if (_self instanceof thingml.xthingml.thingML.CompositeState) {
		result = thingml.xthingml.aspects.ACompositeState
				.runASpontaneousTransition((thingml.xthingml.thingML.CompositeState) _self, dynamicInstance);
	} else if (_self instanceof thingml.xthingml.thingML.State) {
		fr.inria.diverse.k3.al.annotationprocessor.stepmanager.StepCommand command = new fr.inria.diverse.k3.al.annotationprocessor.stepmanager.StepCommand() {
			@Override
			public void execute() {
				addToResult(thingml.xthingml.aspects.AState._privk3_runASpontaneousTransition(_self_,
						(thingml.xthingml.thingML.State) _self, dynamicInstance));
			}
		};
		fr.inria.diverse.k3.al.annotationprocessor.stepmanager.IStepManager manager = fr.inria.diverse.k3.al.annotationprocessor.stepmanager.StepManagerRegistry
				.getInstance().findStepManager(_self);
		if (manager != null) {
			manager.executeStep(_self, command, "State", "runASpontaneousTransition");
		} else {
			command.execute();
		}
		result = command.getResult();
		;
	} else {
		throw new IllegalArgumentException(
				"Unhandled parameter types: " + java.util.Arrays.<Object>asList(_self).toString());
	}
	;
	return (boolean) result;
}
  
  @Step
  public static boolean runAEventDrivenTransition(final State _self, final DynamicInstance dynamicInstance, final DynamicMessage dynamicMessage) {
	final thingml.xthingml.aspects.AStateStateAspectProperties _self_ = thingml.xthingml.aspects.AStateStateAspectContext
			.getSelf(_self);
	Object result = null;
	if (_self instanceof thingml.xthingml.thingML.FinalState) {
		fr.inria.diverse.k3.al.annotationprocessor.stepmanager.StepCommand command = new fr.inria.diverse.k3.al.annotationprocessor.stepmanager.StepCommand() {
			@Override
			public void execute() {
				addToResult(thingml.xthingml.aspects.AState._privk3_runAEventDrivenTransition(_self_,
						(thingml.xthingml.thingML.FinalState) _self, dynamicInstance, dynamicMessage));
			}
		};
		fr.inria.diverse.k3.al.annotationprocessor.stepmanager.IStepManager manager = fr.inria.diverse.k3.al.annotationprocessor.stepmanager.StepManagerRegistry
				.getInstance().findStepManager(_self);
		if (manager != null) {
			manager.executeStep(_self, command, "State", "runAEventDrivenTransition");
		} else {
			command.execute();
		}
		result = command.getResult();
		;
	} else if (_self instanceof thingml.xthingml.thingML.CompositeState) {
		result = thingml.xthingml.aspects.ACompositeState.runAEventDrivenTransition(
				(thingml.xthingml.thingML.CompositeState) _self, dynamicInstance, dynamicMessage);
	} else if (_self instanceof thingml.xthingml.thingML.State) {
		fr.inria.diverse.k3.al.annotationprocessor.stepmanager.StepCommand command = new fr.inria.diverse.k3.al.annotationprocessor.stepmanager.StepCommand() {
			@Override
			public void execute() {
				addToResult(thingml.xthingml.aspects.AState._privk3_runAEventDrivenTransition(_self_,
						(thingml.xthingml.thingML.State) _self, dynamicInstance, dynamicMessage));
			}
		};
		fr.inria.diverse.k3.al.annotationprocessor.stepmanager.IStepManager manager = fr.inria.diverse.k3.al.annotationprocessor.stepmanager.StepManagerRegistry
				.getInstance().findStepManager(_self);
		if (manager != null) {
			manager.executeStep(_self, command, "State", "runAEventDrivenTransition");
		} else {
			command.execute();
		}
		result = command.getResult();
		;
	} else {
		throw new IllegalArgumentException(
				"Unhandled parameter types: " + java.util.Arrays.<Object>asList(_self).toString());
	}
	;
	return (boolean) result;
}
  
  public static void onEntry(final State _self, final DynamicInstance dynamicInstance) {
	final thingml.xthingml.aspects.AStateStateAspectProperties _self_ = thingml.xthingml.aspects.AStateStateAspectContext
			.getSelf(_self);
	_privk3_onEntry(_self_, _self, dynamicInstance);
	;
}
  
  public static void onExit(final State _self, final DynamicInstance dynamicInstance) {
	final thingml.xthingml.aspects.AStateStateAspectProperties _self_ = thingml.xthingml.aspects.AStateStateAspectContext
			.getSelf(_self);
	_privk3_onExit(_self_, _self, dynamicInstance);
	;
}
  
  protected static EList<CompositeState> _privk3__getRootPath(final AStateStateAspectProperties _self_, final State _self, final State state) {
    final BasicEList<CompositeState> path = new BasicEList<CompositeState>();
    EObject parent = state.eContainer();
    while ((parent instanceof CompositeState)) {
      {
        EObject _eContainer = state.eContainer();
        path.add(0, ((CompositeState) _eContainer));
        parent = ((CompositeState)parent).eContainer();
      }
    }
    return path;
  }
  
  protected static EList<CompositeState> _privk3__getPathToState(final AStateStateAspectProperties _self_, final State _self, final DynamicInstance dynamicInstance, final State state1, final State state2) {
    CompositeState ancestor = null;
    final EList<CompositeState> path1 = AState._getRootPath(_self, state1);
    final EList<CompositeState> path2 = AState._getRootPath(_self, state2);
    while ((((!path1.isEmpty()) && (!path2.isEmpty())) && Objects.equal(IterableExtensions.<CompositeState>head(path1), IterableExtensions.<CompositeState>head(path2)))) {
      {
        path1.remove(0);
        ancestor = path2.remove(0);
      }
    }
    path2.add(0, ancestor);
    return path2;
  }
  
  protected static void _privk3__switchState(final AStateStateAspectProperties _self_, final State _self, final DynamicInstance dynamicInstance, final State newState) {
    final EList<CompositeState> ancestorToNewState = AState._getPathToState(_self, dynamicInstance, _self, newState);
    String _name = IterableExtensions.<CompositeState>head(ancestorToNewState).getName();
    String _plus = ("Common ancestor is : " + _name);
    Log.log(_plus, 2);
    EObject _eContainer = _self.eContainer();
    CompositeState compositeState = ((CompositeState) _eContainer);
    while ((compositeState != IterableExtensions.<CompositeState>head(ancestorToNewState))) {
      {
        DynamicCompositeState _dynamicCompositeState = ADynamicInstance.getDynamicCompositeState(dynamicInstance, ((CompositeState) compositeState));
        _dynamicCompositeState.setCurrentState(null);
        EObject _eContainer_1 = compositeState.eContainer();
        compositeState = ((CompositeState) _eContainer_1);
      }
    }
    compositeState = ancestorToNewState.remove(0);
    while ((!ancestorToNewState.isEmpty())) {
      {
        DynamicCompositeState _dynamicCompositeState = ADynamicInstance.getDynamicCompositeState(dynamicInstance, compositeState);
        _dynamicCompositeState.setCurrentState(IterableExtensions.<CompositeState>head(ancestorToNewState));
        compositeState = ancestorToNewState.remove(0);
      }
    }
    DynamicCompositeState _dynamicCompositeState = ADynamicInstance.getDynamicCompositeState(dynamicInstance, compositeState);
    _dynamicCompositeState.setCurrentState(newState);
  }
  
  protected static boolean _privk3_runASpontaneousTransition(final AStateStateAspectProperties _self_, final State _self, final DynamicInstance dynamicInstance) {
    String _name = dynamicInstance.getInstance().getName();
    String _plus = (_name + ": Trying to move from State \'");
    String _name_1 = _self.getName();
    String _plus_1 = (_plus + _name_1);
    String _plus_2 = (_plus_1 + "\'");
    Log.log(_plus_2);
    Log.tab();
    final Function1<InternalTransition, Boolean> _function = (InternalTransition i) -> {
      Event _event = i.getEvent();
      return Boolean.valueOf((_event == null));
    };
    Iterable<InternalTransition> _filter = IterableExtensions.<InternalTransition>filter(_self.getInternal(), _function);
    final Function1<Transition, Boolean> _function_1 = (Transition t) -> {
      Event _event = t.getEvent();
      return Boolean.valueOf((_event == null));
    };
    Iterable<Transition> _filter_1 = IterableExtensions.<Transition>filter(_self.getOutgoing(), _function_1);
    final Iterable<Handler> transitions = Iterables.<Handler>concat(_filter, _filter_1);
    for (final Handler transition : transitions) {
      boolean _isValid = AHandler.isValid(transition, dynamicInstance);
      if (_isValid) {
        final State newState = AHandler.fire(transition, _self, dynamicInstance);
        if ((_self != newState)) {
          String _name_2 = dynamicInstance.getInstance().getName();
          String _plus_3 = (_name_2 + ": Switching state -> ");
          String _name_3 = newState.getName();
          String _plus_4 = (_plus_3 + _name_3);
          Log.log(_plus_4);
          Log.tab();
          AState._switchState(_self, dynamicInstance, newState);
          Log.detab();
          if ((newState instanceof FinalState)) {
            String _name_4 = dynamicInstance.getInstance().getName();
            String _plus_5 = (_name_4 + ": Entered final state");
            Log.log(_plus_5);
            Instance _instance = dynamicInstance.getInstance();
            AInstance.running(_instance, false);
          }
        } else {
          String _name_5 = _self.getName();
          String _plus_6 = ("Staying in state \'" + _name_5);
          String _plus_7 = (_plus_6 + "\'");
          Log.log(_plus_7);
        }
        Log.detab();
        return true;
      }
    }
    Log.detab();
    return false;
  }
  
  protected static boolean _privk3_runAEventDrivenTransition(final AStateStateAspectProperties _self_, final State _self, final DynamicInstance dynamicInstance, final DynamicMessage dynamicMessage) {
    String _name = dynamicInstance.getInstance().getName();
    String _plus = (_name + ": Trying to move from State \'");
    String _name_1 = _self.getName();
    String _plus_1 = (_plus + _name_1);
    String _plus_2 = (_plus_1 + "\'");
    Log.log(_plus_2);
    Log.tab();
    final Function1<InternalTransition, Boolean> _function = (InternalTransition i) -> {
      return Boolean.valueOf(((i.getEvent() instanceof ReceiveMessage) && (((ReceiveMessage) i.getEvent()).getMessage() == dynamicMessage.getMessage())));
    };
    final Iterable<InternalTransition> internals = IterableExtensions.<InternalTransition>filter(_self.getInternal(), _function);
    final Function1<Transition, Boolean> _function_1 = (Transition o) -> {
      return Boolean.valueOf(((o.getEvent() instanceof ReceiveMessage) && (((ReceiveMessage) o.getEvent()).getMessage() == dynamicMessage.getMessage())));
    };
    final Iterable<Transition> outgoings = IterableExtensions.<Transition>filter(_self.getOutgoing(), _function_1);
    final Iterable<Handler> transitions = Iterables.<Handler>concat(internals, outgoings);
    for (final Handler transition : transitions) {
      boolean _isValid = AHandler.isValid(transition, dynamicInstance);
      if (_isValid) {
        final State newState = AHandler.fire(transition, _self, dynamicInstance);
        if ((_self != newState)) {
          String _name_2 = dynamicInstance.getInstance().getName();
          String _plus_3 = (_name_2 + ": Switching state -> ");
          String _name_3 = newState.getName();
          String _plus_4 = (_plus_3 + _name_3);
          Log.log(_plus_4);
          Log.tab();
          AState._switchState(_self, dynamicInstance, newState);
          Log.detab();
          if ((newState instanceof FinalState)) {
            String _name_4 = dynamicInstance.getInstance().getName();
            String _plus_5 = (_name_4 + ": Entered final state");
            Log.log(_plus_5);
            Instance _instance = dynamicInstance.getInstance();
            AInstance.running(_instance, false);
          }
        } else {
          String _name_5 = _self.getName();
          String _plus_6 = ("Staying in state \'" + _name_5);
          String _plus_7 = (_plus_6 + "\'");
          Log.log(_plus_7);
        }
        Log.detab();
        return true;
      }
    }
    Log.detab();
    return false;
  }
  
  protected static void _privk3_onEntry(final AStateStateAspectProperties _self_, final State _self, final DynamicInstance dynamicInstance) {
    Action _entry = _self.getEntry();
    boolean _tripleNotEquals = (_entry != null);
    if (_tripleNotEquals) {
      String _name = dynamicInstance.getInstance().getName();
      String _plus = (_name + ": ");
      String _name_1 = _self.getName();
      String _plus_1 = (_plus + _name_1);
      String _plus_2 = (_plus_1 + ".entry");
      Log.log(_plus_2);
      Log.tab();
      AAction.execute(_self.getEntry(), dynamicInstance);
      Log.detab();
    }
  }
  
  protected static void _privk3_onExit(final AStateStateAspectProperties _self_, final State _self, final DynamicInstance dynamicInstance) {
    Action _exit = _self.getExit();
    boolean _tripleNotEquals = (_exit != null);
    if (_tripleNotEquals) {
      String _name = dynamicInstance.getInstance().getName();
      String _plus = (_name + ": ");
      String _name_1 = _self.getName();
      String _plus_1 = (_plus + _name_1);
      String _plus_2 = (_plus_1 + ".exit");
      Log.log(_plus_2);
      Log.tab();
      AAction.execute(_self.getExit(), dynamicInstance);
      Log.detab();
    }
  }
}
