package org.eclipse.gemoc.executionframework.property.monitor.esper.properties;

import java.util.List;
import java.util.Map;
import org.eclipse.gemoc.executionframework.property.model.property.After;
import org.eclipse.gemoc.executionframework.property.model.property.Response;
import org.eclipse.gemoc.executionframework.property.monitor.esper.TruthValue;
import org.eclipse.gemoc.executionframework.property.monitor.esper.properties.AbstractTemporalProperty;
import org.eclipse.viatra.query.patternlanguage.emf.specification.SpecificationBuilder;
import org.eclipse.viatra.query.runtime.api.IQuerySpecification;
import org.eclipse.xtend2.lib.StringConcatenation;

@SuppressWarnings("all")
public class SRespondsToPAfterQ extends AbstractTemporalProperty {
  private final IQuerySpecification<?> p;
  
  private final IQuerySpecification<?> s;
  
  private final IQuerySpecification<?> q;
  
  public SRespondsToPAfterQ(final SpecificationBuilder builder, final String name, final Response response, final After after) {
    super(builder, name);
    this.p = builder.getOrCreateSpecification(response.getPattern());
    this.s = builder.getOrCreateSpecification(response.getOtherPattern());
    this.q = builder.getOrCreateSpecification(after.getLowerBoundPattern());
    this.queries.put(this.p.getFullyQualifiedName(), this.p);
    this.queries.put(this.q.getFullyQualifiedName(), this.q);
    this.queries.put(this.s.getFullyQualifiedName(), this.s);
  }
  
  @Override
  protected String getStatementString() {
    final String pFqn = this.getFqn(this.p);
    final String sFqn = this.getFqn(this.s);
    final String qFqn = this.getFqn(this.q);
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("select * from ");
    String _name = this.getName();
    _builder.append(_name);
    _builder.newLineIfNotEmpty();
    _builder.append("match_recognize (");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("measures P as P, Q as Q, S as S");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("pattern (EoE | Q nP* (P nS* S nP*)* (P nS*)? EoE)");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("define");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("P as P.");
    _builder.append(pFqn, "\t\t");
    _builder.append("? is not null,");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    _builder.append("S as S.");
    _builder.append(sFqn, "\t\t");
    _builder.append("? is not null,");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    _builder.append("Q as Q.");
    _builder.append(qFqn, "\t\t");
    _builder.append("? is not null,");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    _builder.append("nP as nP.");
    _builder.append(pFqn, "\t\t");
    _builder.append("? is null,");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    _builder.append("nS as nS.");
    _builder.append(sFqn, "\t\t");
    _builder.append("? is null,");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    _builder.append("EoE as EoE.executionAboutToStop? is not null");
    _builder.newLine();
    _builder.append(")");
    _builder.newLine();
    final String result = _builder.toString();
    return result;
  }
  
  @Override
  protected TruthValue getStatus(final Map<String, List<Map<?, ?>>> events) {
    final List<Map<?, ?>> lP = events.get("P");
    int _xifexpression = (int) 0;
    if ((lP == null)) {
      _xifexpression = 0;
    } else {
      _xifexpression = lP.size();
    }
    final int nP = _xifexpression;
    final List<Map<?, ?>> lQ = events.get("Q");
    final boolean reachedQ = (!((lQ == null) || lQ.isEmpty()));
    final List<Map<?, ?>> lS = events.get("S");
    int _xifexpression_1 = (int) 0;
    if ((lS == null)) {
      _xifexpression_1 = 0;
    } else {
      _xifexpression_1 = lS.size();
    }
    final int nS = _xifexpression_1;
    if (reachedQ) {
      if ((nP == nS)) {
        return TruthValue.SATISFIED;
      } else {
        return TruthValue.VIOLATED;
      }
    } else {
      return TruthValue.SATISFIED;
    }
  }
}
