package org.eclipse.gemoc.executionframework.property.tests.minijava

import java.util.ArrayList
import java.util.Collection
import org.eclipse.gemoc.executionframework.property.tests.TestData

class MiniJavaTestData extends TestData {
	
	def static Collection<Object[]> getData() {
		val result = new ArrayList<Object[]>

		if ((modelNameProperty !== null && !modelNameProperty.empty) &&
			(propertyIdProperty !== null && !propertyIdProperty.empty)) {
			result.add(#[modelNameProperty, Integer.parseInt(propertyIdProperty)])
		} else {
			val names = #[
				#{"benchmarking_model_x1_t10.xminijava" -> 25},
				#{"benchmarking_model_x10_t10.xminijava" -> 50},
				#{"benchmarking_model_x100_t10.xminijava" -> 75},
				#{"benchmarking_model_x1_t100.xminijava" -> 25},
				#{"benchmarking_model_x10_t100.xminijava" -> 50},
				#{"benchmarking_model_x100_t100.xminijava" -> 75}
//				#{"benchmarking_model_x1_t1000.xminijava" -> 25},
//				#{"benchmarking_model_x10_t1000.xminijava" -> 50},
//				#{"benchmarking_model_x100_t1000.xminijava" -> 75}
			]
	
			for (nameMap : names) {
				val name = nameMap.keySet.findFirst[true]
				val nbProperties = nameMap.get(name)
				result.add(#[name, -2])
				result.add(#[name, -1])
				for (scenarioID : 0 .. nbProperties - 1) {
					result.add(#[name, scenarioID])
				}
			}
		}
		
		return result
	}
}