package org.eclipse.gemoc.executionframework.property.tests.minijava

class ModelGenerator {
	
	def static void main(String[] args) {
		println(generateModel(1000, 1))
//		println(generatePatterns(99))
//		println(generateScopes(99))
	}
	
	def static String generateScopes(int size) {
		return
			'''
			package minijava.queries
			
			import "http://org.tetrabox.minijava.xminijava/miniJava/"
			
			pattern miniJavaBeforeScope() {
				«FOR i: 0..size»
				find miniJavaScopeIntegerValue(0, "beforeVar_«i»");
				«ENDFOR»
			}
			
			pattern miniJavaAfterScope() {
				«FOR i: 0..size»
				find miniJavaScopeIntegerValue(0, "afterVar_«i»");
				«ENDFOR»
			}
			
			pattern miniJavaBetween1Scope() {
				«FOR i: 0..size»
				find miniJavaScopeIntegerValue(0, "betweenVar1_«i»");
				«ENDFOR»
			}
			
			pattern miniJavaBetween2Scope() {
				«FOR i: 0..size»
				find miniJavaScopeIntegerValue(5, "betweenVar2_«i»");
				«ENDFOR»
			}
			
			pattern miniJavaAfterUntil1Scope() {
				«FOR i: 0..size»
				find miniJavaScopeIntegerValue(0, "afterUntilVar1_«i»");
				«ENDFOR»
			}
			
			pattern miniJavaAfterUntil2Scope() {
				«FOR i: 0..size»
				find miniJavaScopeIntegerValue(5, "afterUntilVar2_«i»");
				«ENDFOR»
			}
			
			pattern miniJavaScopeIntegerValue(iVal: java Integer, sVal: java String) {
				SymbolBinding.symbol(someBinding, someSymbol);
				SymbolBinding.value(someBinding, someValue);
				Symbol.name(someSymbol, sVal);
				IntegerValue.value(someValue, iVal);
			}
			'''
	}
	
	def static String generatePatterns(int size) {
		return
			'''
			package minijava.queries
			
			import "http://org.tetrabox.minijava.xminijava/miniJava/"
			
			pattern miniJavaAlwaysPattern() {
				«FOR i: 0..size»
				neg find miniJavaPatternIntegerValue(10, "alwaysVar_«i»");
				«ENDFOR»
			}
			
			pattern miniJavaExistsPattern() {
				«FOR i: 0..size»
				find miniJavaPatternIntegerValue(3, "existsVar_«i»");
				«ENDFOR»
			}
			
			pattern miniJavaNeverPattern() {
				«FOR i: 0..size»
				find miniJavaPatternIntegerValue(10, "neverVar_«i»");
				«ENDFOR»
			}
			
			pattern miniJavaPrecedence1Pattern() {
				«FOR i: 0..size»
				find miniJavaPatternIntegerValue(1, "precedenceVar1_«i»");
				«ENDFOR»
			}
			
			pattern miniJavaPrecedence2Pattern() {
				«FOR i: 0..size»
				find miniJavaPatternIntegerValue(4, "precedenceVar2_«i»");
				«ENDFOR»
			}
			
			pattern miniJavaResponse1Pattern() {
				«FOR i: 0..size»
				find miniJavaPatternIntegerValue(1, "responseVar1_«i»");
				«ENDFOR»
			}
			
			pattern miniJavaResponse2Pattern() {
				«FOR i: 0..size»
				find miniJavaPatternIntegerValue(4, "responseVar2_«i»");
				«ENDFOR»
			}
			
			pattern miniJavaPrecedence3Pattern() {
				«FOR i: 0..size»
				find miniJavaPatternIntegerValue(0, "precedenceVar3_«i»");
				«ENDFOR»
			}
			
			pattern miniJavaPrecedence4Pattern() {
				«FOR i: 0..size»
				find miniJavaPatternIntegerValue(0, "precedenceVar4_«i»");
				«ENDFOR»
			}
			
			pattern miniJavaPatternIntegerValue(iVal: java Integer, sVal: java String) {
				SymbolBinding.symbol(someBinding, someSymbol);
				SymbolBinding.value(someBinding, someValue);
				Symbol.name(someSymbol, sVal);
				IntegerValue.value(someValue, iVal);
			}
			'''
	}
	
	def static String generateModel(int time, int size) {
		return
			'''
			package minijava.samples;
			
			public class HelloWorld {
			
			    public static void main(String[] args) {
			        «FOR i : 0..size»
			        int alwaysVar_«i» = 0;
			        «ENDFOR»
			        «FOR i : 0..size»
			        int existsVar_«i» = 0;
			        «ENDFOR»
					«FOR i : 0..size»
					int absenceVar_«i» = 0;
			        «ENDFOR»
					«FOR i : 0..size»
					int precedenceVar1_«i» = 0;
			        «ENDFOR»
					«FOR i : 0..size»
					int precedenceVar2_«i» = 0;
			        «ENDFOR»
					«FOR i : 0..size»
					int precedenceVar3_«i» = -91;
			        «ENDFOR»
					«FOR i : 0..size»
					int precedenceVar4_«i» = -93;
			        «ENDFOR»
					«FOR i : 0..size»
					int responseVar1_«i» = 0;
			        «ENDFOR»
					«FOR i : 0..size»
					int responseVar2_«i» = 0;
			        «ENDFOR»
					«FOR i : 0..size»
					int afterVar_«i» = -50;
			        «ENDFOR»
					«FOR i : 0..size»
					int beforeVar_«i» = -95;
			        «ENDFOR»
					«FOR i : 0..size»
					int betweenVar1_«i» = 0;
			        «ENDFOR»
					«FOR i : 0..size»
					int betweenVar2_«i» = 0;
			        «ENDFOR»
					«FOR i : 0..size»
					int afterUntilVar1_«i» = 0;
			        «ENDFOR»
			        «FOR i : 0..size»
			        int afterUntilVar2_«i» = 0;
			        «ENDFOR»
			        for (int j = 0; j < «time»; j = j + 1) {
				        «FOR i : 0..size»
				        alwaysVar_«i» = j % 10;
				        «ENDFOR»
				        «FOR i : 0..size»
				        existsVar_«i» = j % 10;
				        «ENDFOR»
				        «FOR i : 0..size»
				        absenceVar_«i» = j % 10;
				        «ENDFOR»
				        «FOR i : 0..size»
				        precedenceVar1_«i» = j % 10;
				        «ENDFOR»
				        «FOR i : 0..size»
				        precedenceVar2_«i» = j % 10;
				        «ENDFOR»
				        «FOR i : 0..size»
				        precedenceVar3_«i» = precedenceVar3_«i» + 1;
				        «ENDFOR»
				        «FOR i : 0..size»
				        precedenceVar4_«i» = precedenceVar4_«i» + 1;
				        «ENDFOR»
				        «FOR i : 0..size»
				        responseVar1_«i» = j % 10;
				        «ENDFOR»
				        «FOR i : 0..size»
				        responseVar2_«i» = j % 10;
				        «ENDFOR»
				        «FOR i : 0..size»
				        afterVar_«i» = afterVar_«i» + 1;
				        «ENDFOR»
				        «FOR i : 0..size»
				        beforeVar_«i» = beforeVar_«i» + 1;
				        «ENDFOR»
				        «FOR i : 0..size»
				        betweenVar1_«i» = j % 10;
				        «ENDFOR»
				        «FOR i : 0..size»
				        betweenVar2_«i» = j % 10;
				        «ENDFOR»
				        «FOR i : 0..size»
				        afterUntilVar1_«i» = j % 10;
				        «ENDFOR»
				        «FOR i : 0..size»
				        afterUntilVar2_«i» = j % 10;
				        «ENDFOR»
			        	
			        	System.out.println("j="+j);
			        }
			    }
			}
			'''
	}
	
}