package org.eclipse.gemoc.executionframework.property.tests.thingml

import java.util.ArrayList
import java.util.Collection
import org.eclipse.gemoc.executionframework.property.tests.TestData

class ThingMLTestData extends TestData {
	
	def static Collection<Object[]> getData() {
		val result = new ArrayList<Object[]>
		
		if ((modelNameProperty !== null && !modelNameProperty.empty) &&
			(propertyIdProperty !== null && !propertyIdProperty.empty)) {
			result.add(#[modelNameProperty, Integer.parseInt(propertyIdProperty)])
		} else {
			val names = #[
				#{"thingML_benchmarking_5c_3p.thingml" -> 25},
				#{"thingML_benchmarking_25c_5p.thingml" -> 50},
				#{"thingML_benchmarking_75c_6p.thingml" -> 75},
				#{"thingML_benchmarking_5c_20p.thingml" -> 25},
				#{"thingML_benchmarking_25c_20p.thingml" -> 50},
				#{"thingML_benchmarking_75c_20p.thingml" -> 75}
//				#{"thingML_benchmarking_5c_200p.thingml" -> 25},
//				#{"thingML_benchmarking_25c_100p.thingml" -> 50},
//				#{"thingML_benchmarking_75c_40p.thingml" -> 75}
			]
	
			for (nameMap : names) {
				val name = nameMap.keySet.findFirst[true]
				val nbProperties = nameMap.get(name)
				result.add(#[name, -2])
				result.add(#[name, -1])
				
				for (scenarioID : 0 .. nbProperties - 1) {
					result.add(#[name, scenarioID])
				}
			}
		}
		
		return result
	}
}
